package tutorial.test;

import org.exrpp.annotations.*;

import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;

public class Server implements IServer{

	private static final long serialVersionUID = 8652760465703039685L;

	protected Server() throws RemoteException {
		super();
	}

	
	public void foo(@Copy A p, @RemoteReference A q, @CopyRestore A r) throws RemoteException{
	
		System.out.println("[INFO] p before change:" + p);
		p.setMessage("BYE");
		System.out.println("[INFO] p after change:" + p + "\n");

		System.out.println("[INFO] q before change:" + q);
		q.setMessage("BYE");
		System.out.println("[INFO] q after change:" + q + "\n");
		
		System.out.println("[INFO] r before change:" + r);
		r.setMessage("BYE");
		System.out.println("[INFO] r after change:" + r + "\n");
		
	}

	/*
	public void foo(@RemoteReference A p) throws RemoteException {
		System.out.println("[INFO] p before change:" + p);
		p.setMessage("BYE");
		//System.out.println("[INFO] Object Type:" + p.getClass());
		System.out.println("[INFO] p after change:" + p);
	}
	*/
	
	public static void main(String [] args) throws Exception{
		Server s = new Server();
		Registry registry = LocateRegistry.createRegistry(1098);
		System.out.println("Registry found");
		IServer stub = (IServer) UnicastRemoteObject.exportObject(s,0);
		System.out.println("Exported object");
		registry.rebind("s", stub);
		System.out.println("Bound s");
	}

}
